#include <amxmodx>
#include <fakemeta>

static const PLUGIN_NAME[] 		= "Reality"
static const PLUGIN_AUTHOR[] 	= "se7h"
static const PLUGIN_VERSION[]	= "1.89"

#define DEFSPEED	280.0	// default maxspeed
#define VOL_STEP	0.4		// volume of run
#define VOL_WALK	0.1		// volume of walk
#define STEPLEN		51.5		// lenght of step in run (1.3m/0.0254)

// parametres of light from flashes of shots
#define WR			255	// red
#define WG			150	// green
#define WB			15	// blue
#define WRADIUS		16	// radius of light
#define WLIFE		5	// life
#define WDECAY		255	// decay

// flashbang light parameters
#define FR			255	// red
#define FG			255	// green
#define FB			255	// blue
#define FRADIUS		30	// radius of light
#define FLIFE		5	// life
#define FDECAY		255	// decay

// Sum (HEAD + CHEST + STOMACH) it should be equaled 100
#define HEAD		20.0		// amount armor of helm
#define CHEST		40.0		// amount armor of kevlar chest part
#define STOMACH		40.0		// amount armor of kevlar stomach part

#define HPLOSE_TASK		191817
#define DEFSOUND_TASK	192457
#define SFX_TASK		846225
#define NORMAL_TASK		324782
#define WEARINESS_TASK	743827
#define REST_TASK		783827

#define OFFSET_ARMORTYPE	112
#define OFFSET_SHIELD		510
#define OFFSET_NVGOGGLES	129
#define OFFSET_DEFUSE_PLANT	193
#define EXTRAOFFSET_WEAPONS	4
#define HAS_NVGOGGLES	(1<<0)
#define HAS_DEFUSE_KIT	(1<<16) 
#define HAS_SHIELD     	(1<<24)
#define M4A1_SILENCED	(1<<2)
#define USP_SILENCED	(1<<0)
#define m_iSilencerFireMode	74

// Weight, kg
#define SHIELD		17.0
#define KEVLAR		4.5
#define VESTHELM	6.0
#define DEFUSE		1.5
#define NVG			0.7

new g_aiOffsets[14] =
{
	377,
	378,
	379,
	380,
	381,
	382,
	383,
	384,
	385,
	386,
	387,
	388,
	389,
	390
}

// Weight, kg
new Float:g_afAmmoWeight[14] =
{
	0.016,		//.338LM bullet
	0.0095,		// 7.62mm bullet
	0.004,		// 5.56mm M249 bullet
	0.004,		// 5.56mm other bullet
	0.0378,		// 12 GAUGE bullet
	0.015,		// .45ACP bullet
	0.0026,		// 5.7mm bullet
	0.0211,		// .50AE bullet
	0.0081,		// .357SIG bullet
	0.008,		// 9mm bullet
	0.25,		// Flashbang
	0.5,		// HEnade
	0.35,		// Smokenade
	1.5			// Bomb
}

new g_aiWeaponId[25] =
{
	1,
	3,
	5,
	7,
	8,
	10,
	11,
	12,
	13,
	14,
	15,
	16,
	17,
	18,
	19,
	20,
	21,
	22,
	23,
	24,
	26,
	27,
	28,
	29,
	30
}

// Weight, kg
new Float:g_afWeaponWeight[25] =
{
	0.802,		// P228
	3.5,		// Scout
	3.8,		// XM1014
	2.84,		// MAC10
	3.6,		// Aug
	2.02,		// Elite
	0.617,		// Fiveseven
	2.3,		// UMP45
	7.02,		// SG550
	4.35,		// Galil
	3.61,		// Famas
	0.789,		// USP
	0.67,		// Glock18
	6.5,		// AWP
	3.08,		// MP5Navy
	7.484,		// M249
	3.5,		// M3
	3.1,		// M4A1
	1.3,		// TMP
	5.54,		// G3SG1
	1.766,		// Desert Eagle
	3.2,		// SG552
	3.03,		// AK47
	0.35,		// Knife
	2.54			// P90
}

new bool:g_bReal, bool:g_bBleed, bool:g_bSteps, bool:g_bFlash, bool:g_bDamaged, bool:g_bFLight, bool:g_bWLight, bool:g_bRealArm, g_iRealSpeed
new Float:g_afLegHits[33], g_aiWeapon[33][32], g_aiAttacker[33], g_aiBleedWounds[33], g_aiWounds[33], Float:g_afArmHead[33], Float:g_afArmChest[33], Float:g_afArmStomach[33]
new bool:g_bFreeze, bool:g_abSFX[33], g_aiWalk[33], g_aiWalkTime[33], Float:g_afNewSpeed[33], bool:g_abInWalk[33], bool:g_abSpeedKey[33]
new g_aiBloodSmall[4], g_iMaxPlayers, Float:g_fHPLose, Float:g_fHPTimeLose, Float:g_fSpeedLose, g_iWalk, Float:g_fMinHP, Float:g_afLoss[33], bool:g_abDead[33]
new g_iMsgFade, g_iMsgShake, g_iMsgStatusIcon, g_iMsgScoreInfo, g_iMsgArmorType, bool:g_abPlayerNonSpawnEvent[33], g_iFwFmClientCommandPost

new const g_szHeartBeats[] = "player/heartbeats.wav"
new const g_szBoom[] = "player/heffect.wav"
new const g_szScream[] = "player/die2.wav"
new const g_szBreeze[] = "player/breeze.wav"
new const g_szFlashed[] = "player/flashbanged.wav"

new g_aszMetalSteps[4][] = 
{
	"player/pl_metal1.wav",
	"player/pl_metal2.wav",
	"player/pl_metal3.wav",
	"player/pl_metal4.wav"
}

new g_aszVentSteps[4][] = 
{
	"player/pl_duct1.wav",
	"player/pl_duct2.wav",
	"player/pl_duct3.wav",
	"player/pl_duct4.wav"
}

new g_aszDirtSteps[4][] = 
{
	"player/pl_dirt1.wav",
	"player/pl_dirt2.wav",
	"player/pl_dirt3.wav",
	"player/pl_dirt4.wav"
}

new g_aszLiquidSteps[4][] = 
{
	"player/pl_slosh1.wav",
	"player/pl_slosh2.wav",
	"player/pl_slosh3.wav",
	"player/pl_slosh4.wav"
}

new g_aszTileSteps[4][] = 
{
	"player/pl_tile1.wav",
	"player/pl_tile2.wav",
	"player/pl_tile3.wav",
	"player/pl_tile4.wav"
}

new g_aszGrateSteps[4][] = 
{
	"player/pl_grate1.wav",
	"player/pl_grate2.wav",
	"player/pl_grate3.wav",
	"player/pl_grate4.wav"
}

new g_aszSnowSteps[4][] = 
{
	"player/pl_snow1.wav",
	"player/pl_snow2.wav",
	"player/pl_snow3.wav",
	"player/pl_snow4.wav"
}

new g_aszDefSteps[4][] = 
{
	"player/pl_step1.wav",
	"player/pl_step2.wav",
	"player/pl_step3.wav",
	"player/pl_step4.wav"
}

new g_aszLadderSteps[4][] = 
{
	"player/pl_ladder1.wav",
	"player/pl_ladder2.wav",
	"player/pl_ladder3.wav",
	"player/pl_ladder4.wav"
}

public plugin_precache()
{
	precache_sound(g_szHeartBeats)
	precache_sound(g_szBoom)
	precache_sound(g_szBreeze)
	precache_sound(g_szFlashed)
}

public plugin_init()
{
	register_plugin(PLUGIN_NAME, PLUGIN_VERSION, PLUGIN_AUTHOR)

	register_cvar("amx_reality", "1")		// 1/0 enable/disable plugin
	register_cvar("real_bleed", "1")		// 1/0 enable/disable bleeding
	register_cvar("real_hplose", "1")		// quantity of losses HP
	register_cvar("real_minhp", "25")		// minimum level of damage after which there are wounds and effects
	register_cvar("real_hptimelose", "3")	// period HP lose
	register_cvar("real_speed", "2")		// 0 - disable real speed, 1 - enable w/o gravity, 2 - enable with gravity
	register_cvar("real_speedlose", "5")	// loss of speed on one kg of ammunition
	register_cvar("real_steps", "1")		// 1/0 enable/disable real footsteps
	register_cvar("real_flashed", "1")		// 1/0 enable/disable flashbang effect
	register_cvar("real_flight", "1")		// 1/0 enable/disable flashbang dynamic light
	register_cvar("real_wlight", "1")		// 1/0 enable/disable light from flashes of shots
	register_cvar("real_damaged", "1")		// 1/0 enable/disable damage effect
	register_cvar("real_timeweariness", "60")// weariness and rest time
	register_cvar("real_armor", "1")		// 1/0 enable/disable real armor
	
	new mod[9]
	get_modname(mod, 8)

	if(equali(mod, "cstrike"))
	{
		g_aiBloodSmall = {190,191,192,193}
	}
	else if(equali(mod, "czero"))
	{
		g_aiBloodSmall = {202,203,204,205}
	}

	register_event("Damage", "event_damage", "be", "2!0")
	register_event("DeathMsg", "event_death", "a", "2!0")
	register_event("HLTV", "event_new_round", "a", "1=0", "2=0")
	register_event("ScreenFade", "event_flashed", "be", "4=255", "5=255", "6=255", "7>199")
	register_event("CurWeapon", "event_curweapon", "be", "1=1")
	register_event("AmmoPickup", "fn_calc_speed", "be")
	register_event("WeapPickup", "fn_calc_speed", "be")
	register_event("ItemStatus", "fn_calc_speed", "be")
	register_event("Battery", "event_armor", "be", "1=100")
	register_event("ResetHUD", "event_reset_HUD", "b")
	register_event("TextMsg", "event_game_will_restart_in", "a", "2=#Game_will_restart_in")
	register_forward(FM_PlayerPostThink, "fw_player_post_think", true)
	register_forward( FM_CmdStart, "fw_fm_cmd_start" )
	register_forward(FM_EmitSound,"fw_emitsound")
	register_logevent("logevent_round_start", 2, "1=Round_Start")
	register_clcmd("fullupdate", "fw_cmd_cl_fullupdate")

	g_iMaxPlayers = get_maxplayers()
	g_iMsgArmorType = get_user_msgid("ArmorType")
	g_iMsgFade = get_user_msgid("ScreenFade")
	g_iMsgShake = get_user_msgid("ScreenShake")
	g_iMsgStatusIcon = get_user_msgid("StatusIcon")
	g_iMsgScoreInfo = get_user_msgid("ScoreInfo")
}

public plugin_cfg()
{
	g_bReal = (get_cvar_num("amx_reality") > 0) ? true : false
	g_bBleed = (get_cvar_num("real_bleed") > 0) ? true : false
	g_bSteps = (get_cvar_num("real_steps") > 0) ? true : false
	g_bFlash = (get_cvar_num("real_flashed") > 0) ? true : false
	g_bFLight = (get_cvar_num("real_flight") > 0) ? true : false
	g_bWLight = (get_cvar_num("real_wlight") > 0) ? true : false	
	g_bDamaged = (get_cvar_num("real_damaged") > 0) ? true : false
	g_bRealArm = (get_cvar_num("real_armor") > 0) ? true : false
	g_fHPLose = get_cvar_float("real_hplose")
	g_fHPTimeLose = get_cvar_float("real_hptimelose")
	g_fSpeedLose = get_cvar_float("real_speedlose")
	g_fMinHP = get_cvar_float("real_minhp")
	g_iWalk = get_cvar_num("real_timeweariness")
	g_iRealSpeed = get_cvar_num("real_speed")
}

public event_death()
{
	static id 
	id = read_data(2)
	
	g_abDead[id] = true

	g_abSFX[id] = false
	g_abInWalk[id] = false
	g_abSpeedKey[id] = false
	g_afLegHits[id] = 0.0
	g_aiBleedWounds[id] = 0
	g_aiWounds[id] = 0
	g_aiWalk[id] = 0
	g_afArmHead[id] = 0.0
	g_afArmChest[id] = 0.0
	g_afArmStomach[id] = 0.0

	fn_end_all_tasks(id)
} 

public event_new_round()
	g_bFreeze = true

public event_reset_HUD(id)
{
	if(!is_user_alive(id))
		return
 
	if(g_abPlayerNonSpawnEvent[id])
	{
		g_abPlayerNonSpawnEvent[id] = false
		return
	}
 
	fw_player_spawn(id)
}
 
public event_game_will_restart_in()
{
	static aiPlayers[32], iPlayersNum, i
	get_players(aiPlayers, iPlayersNum, "a")
	for(i=0; i<iPlayersNum; i++)
		g_abPlayerNonSpawnEvent[aiPlayers[i]] = true
}
 
public fw_cmd_cl_fullupdate(id)
{
	g_abPlayerNonSpawnEvent[id] = true
	static const szFwFmClientCommandPost[] = "fw_fm_client_command_post"
	g_iFwFmClientCommandPost = register_forward(FM_ClientCommand, szFwFmClientCommandPost, 1)
	return PLUGIN_CONTINUE
}
 
public fw_fm_client_command_post(id)
{
	unregister_forward(FM_ClientCommand, g_iFwFmClientCommandPost, 1)
	g_abPlayerNonSpawnEvent[id] = false
	return FMRES_HANDLED
}
 
public fw_player_spawn(id)
{
	g_abDead[id] = false
	g_abSFX[id] = false
	g_abSpeedKey[id] = false
	g_aiWalk[id] = 0
	g_aiBleedWounds[id] = 0
	g_aiWounds[id] = 0
	g_afLegHits[id] = 0.0

	fn_end_all_tasks(id)
		
	fn_calc_speed(id)
}

public event_armor(id)
{
	if(g_bRealArm)
	{
		message_begin(MSG_ONE, g_iMsgArmorType, _, id)
		switch(get_pdata_int(id, OFFSET_ARMORTYPE))
		{
			case 1:
			{
				g_afArmHead[id] = 0.0
				write_byte(0)
			}
			case 2:
			{
				g_afArmHead[id] = HEAD
				write_byte(1)
			}
		}
		message_end()
		
		g_afArmChest[id] = CHEST
		g_afArmStomach[id] = STOMACH
		set_pev(id, pev_armorvalue, g_afArmHead[id]+g_afArmChest[id]+g_afArmStomach[id])
	}

	fn_calc_speed(id)
}

public logevent_round_start()
	g_bFreeze = false

public client_disconnect(id)
	fn_end_all_tasks(id)

public client_putinserver(id)
{
	g_abSFX[id]=false
	set_task(1.0, "fn_default_sound", DEFSOUND_TASK+id)
}

public fn_default_sound(dsid)
{
	static id
	id = dsid - DEFSOUND_TASK
	client_cmd(id, "room_type 1; wait; wait; wait; wait; room_type 0")
}

public event_damage(id)
{
	if(g_bReal)
	{
		static iWeapon, iHitZone, Float:fDamage, iDamageType, iArmorType, Float:fHealth
		fDamage = float(read_data(2))
		iDamageType = read_data(3)
		iArmorType = get_pdata_int(id, OFFSET_ARMORTYPE)
		pev(id, pev_health, fHealth)
		g_aiAttacker[id] = get_user_attacker(id, iWeapon, iHitZone)

		switch(iWeapon)
		{
			case 0: copy(g_aiWeapon[id], 31, "")
			case CSW_HEGRENADE: copy(g_aiWeapon[id], 31, "grenade")
			default:
			{
				get_weaponname(iWeapon, g_aiWeapon[id], 31)
				replace(g_aiWeapon[id], 31, "weapon_", "")
			}
		}

		if(iDamageType & DMG_FALL)
			iHitZone = random_num(6,7)
		else if(!iHitZone)
			iHitZone = random_num(1,7)

		switch(iHitZone)
		{
			case 1:		// HEAD
			{
				switch(iArmorType)
				{
					case 0,1:
					{
						if(fDamage >= g_fMinHP)
							g_aiBleedWounds[id]++
					}
					case 2:
					{
						if(g_bRealArm)
						{
							if(g_afArmHead[id] >= fDamage)
							{
								g_afArmHead[id] -= fDamage
								set_pev(id, pev_health, fHealth+fDamage)
								fDamage = 0.0
							}else if(g_afArmHead[id] > 0.0){
								set_pev(id, pev_health, fHealth+g_afArmHead[id])
								fDamage -= g_afArmHead[id]
								g_afArmHead[id] = 0.0
							}
						}
						if(fDamage >= g_fMinHP)
							g_aiWounds[id]++
					}
				}

			}
			case 2:		// CHEST
			{
				switch(iArmorType)
				{
					case 0:
					{
						if(fDamage >= g_fMinHP)
							g_aiBleedWounds[id]++
					}
					case 1,2:
					{
						if(g_bRealArm)
						{
							if(g_afArmChest[id] >= fDamage)
							{
								g_afArmChest[id] -= fDamage
								set_pev(id, pev_health, fHealth+fDamage)
								fDamage = 0.0
							}else if(g_afArmChest[id] > 0.0){
								set_pev(id, pev_health, fHealth+g_afArmChest[id])
								fDamage -= g_afArmChest[id]
								g_afArmChest[id] = 0.0
							}
						}
						if(fDamage >= g_fMinHP)
							g_aiWounds[id]++
					}
				}
			}
			case 3:		// STOMACH
			{
				switch(iArmorType)
				{
					case 0:
					{
						if(fDamage >= g_fMinHP)
							g_aiBleedWounds[id]++
					}
					case 1,2:
					{
						if(g_bRealArm)
						{
							if(g_afArmStomach[id] >= fDamage)
							{
								g_afArmStomach[id] -= fDamage
								set_pev(id, pev_health, fHealth+fDamage)
								fDamage = 0.0
							}else if(g_afArmStomach[id] > 0.0){
								set_pev(id, pev_health, fHealth+g_afArmStomach[id])
								fDamage -= g_afArmStomach[id]
								g_afArmStomach[id] = 0.0
							}
						}
						if(fDamage >= g_fMinHP)
							g_aiWounds[id]++
					}
				}
			}
			case 4..7:		// LEFTARM, RIGHTARM, LEFTLEG, RIGHTLEG
			{
				if(fDamage >= g_fMinHP)
				{
					if(!(iDamageType & DMG_FALL))
						g_aiBleedWounds[id]++
					else
						g_aiWounds[id]++
				}
			}
		}

		if(iHitZone == 6 || iHitZone == 7)
			g_afLegHits[id] += fDamage

		if(g_bRealArm && iArmorType > 0)
			set_pev(id, pev_armorvalue, g_afArmHead[id]+g_afArmChest[id]+g_afArmStomach[id])

		if(g_bDamaged && fDamage >= g_fMinHP && (iWeapon == CSW_HEGRENADE || iDamageType == DMG_BLAST))
		{
			static Float:afVec[3]
			afVec[0] = random_float(-45.0, 45.0)
			afVec[1] = random_float(-45.0, 45.0)
			afVec[2] = random_float(-45.0, 45.0)
			set_pev(id, pev_punchangle, afVec)

			fn_shake(id, (3<<14), (1<<14), (1<<14))
			fn_fade(id, (1<<12), (1<<12), (2<<10), 70, 0, 0, 150)

			client_cmd(id, "stopsound; spk %s; spk %s; room_type 14", g_szBoom, g_szScream)

			if(!g_abSFX[id])
			{
				client_cmd(id, "spk %s", g_szHeartBeats)
				emit_sound(id, CHAN_VOICE, g_szBreeze, 0.7, ATTN_NORM, 0, PITCH_NORM)
				g_abSFX[id]=true
			}

			if(task_exists(SFX_TASK+id))
				remove_task(SFX_TASK+id)

			set_task(7.0, "fn_SFX", SFX_TASK+id)

			if(!task_exists(NORMAL_TASK+id))
				set_task(25.0, "fn_normal_sound", NORMAL_TASK+id)
		}else if(g_bDamaged && fDamage >= g_fMinHP){
			if(!g_abSFX[id])
			{
				client_cmd(id, "spk %s", g_szHeartBeats)
				emit_sound(id, CHAN_VOICE, g_szBreeze, 0.7, ATTN_NORM, 0, PITCH_NORM)

				g_abSFX[id] = true
			}

			if(task_exists(SFX_TASK+id))
				remove_task(SFX_TASK+id)

			set_task(7.0, "fn_SFX", SFX_TASK+id)

			fn_fade(id, (2<<10), (2<<10), (1<<10), 70, 0, 0, 150)
		}

		fn_calc_speed(id)

		if(!task_exists(HPLOSE_TASK+id))
			set_task(g_fHPTimeLose, "fn_loss_HP", HPLOSE_TASK+id, _, _, "b")

	}
}

public fn_normal_sound(nid)
{
	static id
	id = nid - NORMAL_TASK
	client_cmd(id, "room_type 0")
}

public fn_SFX(sfxid)
{
	static id
	id = sfxid - SFX_TASK
	g_abSFX[id]=false
}

public event_flashed(id)
{
	static iDuration
	iDuration = read_data(1)
	
	if(read_data(7) < 255)
	{
		fn_fade(id, 0, 0, 0, 0, 0, 0, 0)
		iDuration += iDuration - iDuration/4
	}
		
	if(g_bFlash && !is_user_bot(id) && iDuration > (9<<12))
	{
		client_cmd(id, "spk %s;  room_type 14", g_szFlashed)
		if(!task_exists(NORMAL_TASK+id))
			set_task(25.0, "fn_normal_sound", NORMAL_TASK+id)
	}
}

public event_curweapon(id) 
{
	static iWeaponID, iClipAmmo, iLastWeapon[33], iLastAmmo[33]
	
	iWeaponID = read_data(2)
	iClipAmmo = read_data(3)
	
	switch(iWeaponID)
	{
		case CSW_FIVESEVEN, CSW_GLOCK18, CSW_USP, CSW_P228: g_afLoss[id] = 1.0
		case CSW_TMP, CSW_DEAGLE, CSW_ELITE: g_afLoss[id] = 1.5
		case CSW_UMP45, CSW_P90, CSW_MAC10: g_afLoss[id] = 2.0
		case CSW_AK47, CSW_MP5NAVY, CSW_M4A1, CSW_SG552: g_afLoss[id] = 2.5
		case CSW_M3, CSW_SCOUT, CSW_AUG, CSW_FAMAS, CSW_XM1014: g_afLoss[id] = 3.0
		case CSW_GALIL: g_afLoss[id] = 3.5
		case CSW_G3SG1: g_afLoss[id] = 4.0
		case CSW_AWP, CSW_SG550: g_afLoss[id] = 4.5
		case CSW_M249: g_afLoss[id] = 5.0 
		default:
		{
			g_afLoss[id] = (iWeaponID == CSW_C4) ? 1.5 : 0.0
			fn_calc_speed(id)
			return PLUGIN_CONTINUE
		}
	}

	fn_calc_speed(id)
	
	if(g_bWLight && iLastWeapon[id] == iWeaponID && iLastAmmo[id] > iClipAmmo)
		fn_lights_fx(id, (fn_is_silen(id, iWeaponID) ? WRADIUS/2 : WRADIUS), WR, WG, WB, WLIFE, WDECAY)

	iLastWeapon[id] = iWeaponID
	iLastAmmo[id] = iClipAmmo
	
	return PLUGIN_CONTINUE
}

public fn_calc_speed(id)
{
	if(g_iRealSpeed > 0)
	{
		static Float:fWArmor, Float:fWOther, i, j
		static Float:fWBullNadBomb, Float:fWWeapons
		fWBullNadBomb = 0.0
		fWWeapons = 0.0
		
		for(j=0; j<sizeof g_afWeaponWeight; j++)
			fWWeapons += g_afWeaponWeight[j]*user_has_weapon(id, g_aiWeaponId[j])

		for(i=0; i<sizeof g_afAmmoWeight; i++)
			fWBullNadBomb += g_afAmmoWeight[i]*get_pdata_int(id, g_aiOffsets[i])

		switch(get_pdata_int(id, OFFSET_ARMORTYPE))
		{
			case 0: fWArmor = 0.0
			case 1: fWArmor = KEVLAR
			case 2: fWArmor = VESTHELM
		}

		fWOther = SHIELD*fm_get_user_shield(id) + DEFUSE*fm_get_user_defuse(id) + NVG*fm_get_user_nvg(id)

		g_afNewSpeed[id] = DEFSPEED - g_afLegHits[id] - (fWWeapons + fWBullNadBomb + fWArmor + fWOther + g_afLoss[id])*g_fSpeedLose

		g_aiWalkTime[id] = floatround(g_iWalk*g_afNewSpeed[id]/DEFSPEED)
	}
}

public fw_fm_cmd_start(id, uc_handle, randseed)
{
	static Float:fFMove, Float:fSMove
	get_uc(uc_handle, UC_ForwardMove, fFMove)
	get_uc(uc_handle, UC_SideMove, fSMove)

	static Float:fMaxSpeed, Float:fWalkSpeed
	pev(id, pev_maxspeed, fMaxSpeed)
	fWalkSpeed = fMaxSpeed*0.52
	fFMove = floatabs(fFMove)
	fSMove = floatabs(fSMove)
    
	if(fFMove <= fWalkSpeed && fSMove <= fWalkSpeed && !(fFMove == 0.0 && fSMove == 0.0))
		g_abSpeedKey[id] = true
	else
		g_abSpeedKey[id] = false
}

public fw_player_post_think(id)
{
	if(g_bReal && !g_abDead[id] && !g_bFreeze)
	{
		static Float:afMaxSpeed[33], Float:afWalkSpeed[33], bool:abInAir[33], bool:abStand[33], bool:abHasShield[33], Float:afLastTime[33]

		pev(id, pev_maxspeed, afMaxSpeed[id])

		if(!g_abInWalk[id])
		{
			if(g_afNewSpeed[id] != afMaxSpeed[id])
			{
				if(g_afNewSpeed[id] < 1.0)
					g_afNewSpeed[id] = 1.0
				
				switch(g_iRealSpeed)
				{
					case 1: fn_setspeed(id, g_afNewSpeed[id])
					case 2:
					{
						fn_setspeed(id, g_afNewSpeed[id])
						set_pev(id, pev_gravity, DEFSPEED/g_afNewSpeed[id])
					}
				}
			}
		}else{
			if(afMaxSpeed[id] != (afWalkSpeed[id] = (g_iRealSpeed > 0) ? (0.5*g_afNewSpeed[id]) : (0.5*afMaxSpeed[id])))
				fn_setspeed(id, afWalkSpeed[id])
		}
			
		if(fm_get_user_shield(id))
		{
			if(!abHasShield[id])
			{
				fn_calc_speed(id)
				abHasShield[id] = true
			}
		}else{	
			if(abHasShield[id])
			{
				fn_calc_speed(id)
				abHasShield[id] = false
			}
		}
		
		if((pev(id, pev_button) & (IN_FORWARD|IN_BACK|IN_MOVELEFT|IN_MOVERIGHT)))
		{
			static Float:afVelocity[3], Float:afPlayerSpeed[33], Float:afStepPeriod[33]
			pev(id, pev_velocity, afVelocity)
			afPlayerSpeed[id] = vector_length(afVelocity)

			if(afPlayerSpeed[id] > 50.0)
			{
				if(g_bSteps)
				{
					afStepPeriod[id] = STEPLEN/floatclamp(afPlayerSpeed[id], STEPLEN, DEFSPEED)

					if(!task_exists(id))
					{
						if(abStand[id])
						{
							fn_steps_sound(id)
							set_task(afStepPeriod[id]/2.0, "fn_steps_sound", id)
						}

						set_task(afStepPeriod[id], "fn_steps_sound", id)
					}
				}

				if(abStand[id])
					abStand[id] = false
					
				if(!g_abInWalk[id] && !(pev(id, pev_flags) & FL_DUCKING) && !g_abSpeedKey[id])
				{
					if(!task_exists(WEARINESS_TASK+id) && g_aiWalk[id] < g_aiWalkTime[id])
						set_task(1.0, "fn_weariness", WEARINESS_TASK+id)
				}else{
					if(!task_exists(REST_TASK+id) && g_aiWalk[id] > 0)
						set_task(1.0, "fn_rest", REST_TASK+id)
				}
			}
		}else{
			if(!abStand[id])
			{
				abStand[id] = true
				g_abInWalk[id] = false

				if(task_exists(id))
					remove_task(id)
			}

			if(!task_exists(REST_TASK+id) && g_aiWalk[id] > 0)
				set_task(0.5, "fn_rest", REST_TASK+id)
		}

		if(g_bSteps)
		{
			if(pev(id, pev_flags) & FL_ONGROUND)
			{
				if(abInAir[id])
				{
					if((get_gametime() - afLastTime[id]) > 0.1)
						fn_steps_sound(id)
						
					abInAir[id] = false
					afLastTime[id] = get_gametime()
				}
			}else{	
				if(!abInAir[id])
				{
					if((get_gametime() - afLastTime[id]) > 0.1)
						fn_landing_sound(id, random(4))
						
					abInAir[id] = true
					afLastTime[id] = get_gametime()
				}
			}
		}
	}
}

public fn_weariness(walkid)
{
	static id
	id = walkid - WEARINESS_TASK

	if(g_aiWalk[id] < g_aiWalkTime[id])
		g_aiWalk[id]++

	if(g_aiWalk[id] >= g_aiWalkTime[id])
	{
		g_abInWalk[id] = true
		emit_sound(id, CHAN_VOICE, g_szBreeze, 0.7, ATTN_NORM, 0, PITCH_NORM)
	}
	
	fn_weariness_indicator(id)
}

public fn_rest(restid)
{
	static id
	id = restid - REST_TASK

	if(g_aiWalk[id])
		g_aiWalk[id]--

	if(!g_aiWalk[id])
		g_abInWalk[id] = false
		
	fn_weariness_indicator(id)
}

public fn_steps_sound(id)
{
	static iNum[33]

	if(iNum[id] > 3)
		iNum[id] = 0

	if(pev(id, pev_movetype) == MOVETYPE_FLY)
		emit_sound(id, CHAN_BODY, g_aszLadderSteps[iNum[id]], VOL_STEP, ATTN_STATIC, 0, PITCH_NORM)

	if(pev(id, pev_flags) & FL_ONGROUND)
		fn_landing_sound(id, iNum[id])

	iNum[id]++
}

public fn_loss_HP(loseid)
{
	static id, iAttacker, iBleedWounds, iWounds
	id = loseid - HPLOSE_TASK
	
	if(!g_abDead[id] && g_fHPLose > 0.0)
	{
		iBleedWounds = g_aiBleedWounds[id]
		iWounds = g_aiWounds[id]
		
		if((iBleedWounds + iWounds) > 0) 
		{
			static Float:fHealth
			pev(id, pev_health, fHealth)
			if((fHealth - g_fHPLose*(iBleedWounds + iWounds)) < 1.0)
			{
				iAttacker = g_aiAttacker[id]
				
				if(!(1 <= iAttacker <= g_iMaxPlayers) || iAttacker == id)
				{
					user_kill(id, 0)
					fn_refresh_score(id)
					remove_task(loseid)

					return
				}

				if(get_user_team(id) == get_user_team(iAttacker))
					set_pev(iAttacker, pev_frags, float(get_user_frags(iAttacker))-1.0)
				else
					set_pev(iAttacker, pev_frags, float(get_user_frags(iAttacker))+1.0)

				fn_refresh_score(iAttacker)
				fn_refresh_score(id)
				user_silentkill(id)
				make_deathmsg(iAttacker, id, 0, g_aiWeapon[id])
				remove_task(loseid)

				return
			}
			
			fn_draw_icon(id, 2, 0, 0, 0, "item_healthkit")

			if(g_bBleed && iBleedWounds > 0)
				fn_bloody_FX(id)

			set_pev(id, pev_health, fHealth - g_fHPLose*(iBleedWounds + iWounds))
		}else
			remove_task(loseid)
	}
}

public fw_emitsound(entity, channel, sample[])
{
	if(g_bFLight && equali(sample, "weapons/flashbang", 17) && pev_valid(entity))
		fn_lights_fx(entity, FRADIUS, FR, FG, FB, FLIFE, FDECAY)
}

stock fn_landing_sound(id, num)
{
	static Float:fVolStep
	if(g_abSpeedKey[id] || (pev(id, pev_flags) & FL_DUCKING))
		fVolStep = VOL_WALK
	else
		fVolStep = VOL_STEP

	switch(fn_texture_type(id))
	{
		case 'C': emit_sound(id, CHAN_BODY, g_aszDefSteps[num], fVolStep, ATTN_STATIC, 0, PITCH_NORM)
		case 'M': emit_sound(id, CHAN_BODY, g_aszMetalSteps[num], fVolStep, ATTN_STATIC, 0, PITCH_NORM)
		case 'W': emit_sound(id, CHAN_BODY, g_aszTileSteps[num], fVolStep, ATTN_STATIC, 0, PITCH_NORM)
		case 'V': emit_sound(id, CHAN_BODY, g_aszVentSteps[num], fVolStep, ATTN_STATIC, 0, PITCH_NORM)
		case 'D': emit_sound(id, CHAN_BODY, g_aszDirtSteps[num], fVolStep, ATTN_STATIC, 0, PITCH_NORM)
		case 'S': emit_sound(id, CHAN_BODY, g_aszLiquidSteps[num], fVolStep, ATTN_STATIC, 0, PITCH_NORM)
		case 'T': emit_sound(id, CHAN_BODY, g_aszTileSteps[num], fVolStep, ATTN_STATIC, 0, PITCH_NORM)
		case 'G': emit_sound(id, CHAN_BODY, g_aszGrateSteps[num], fVolStep, ATTN_STATIC, 0, PITCH_NORM)
		case 'N': emit_sound(id, CHAN_BODY, g_aszSnowSteps[num], fVolStep, ATTN_STATIC, 0, PITCH_NORM)
		default: emit_sound(id, CHAN_BODY, g_aszDefSteps[num], fVolStep, ATTN_STATIC, 0, PITCH_NORM)
	}	
}

stock fn_end_all_tasks(id)
{
	client_cmd(id, "room_type 0")
	
	fn_draw_icon(id, 0, 0, 0, 0, "dmg_drown")
	fn_draw_icon(id, 0, 0, 0, 0, "item_healthkit")
	
	emit_sound(id, CHAN_VOICE, g_szBreeze, 0.0, 0.0, SND_STOP, PITCH_NORM)
	emit_sound(id, CHAN_STATIC, g_szBoom, 0.0, 0.0, SND_STOP, PITCH_NORM)
	emit_sound(id, CHAN_STATIC, g_szHeartBeats, 0.0, 0.0, SND_STOP, PITCH_NORM)
	emit_sound(id, CHAN_STATIC, g_szFlashed, 0.0, 0.0, SND_STOP, PITCH_NORM)

	if(task_exists(SFX_TASK+id))
		remove_task(SFX_TASK+id)
	if(task_exists(HPLOSE_TASK+id))
		remove_task(HPLOSE_TASK+id)
	if(task_exists(REST_TASK+id))
		remove_task(REST_TASK+id)
	if(task_exists(WEARINESS_TASK+id))
		remove_task(WEARINESS_TASK+id)
}

stock fn_weariness_indicator(id)
{
	if(g_iWalk > 0 && g_aiWalkTime[id] > 0)
	{
		switch(100*g_aiWalk[id]/g_aiWalkTime[id])
		{
			case 0: fn_draw_icon(id, 0, 0, 0, 0, "dmg_drown")
			case 1..32: fn_draw_icon(id, 1, 0, 160, 0, "dmg_drown")
			case 33..65: fn_draw_icon(id, 1, 160, 160, 0, "dmg_drown")
			case 66..99: fn_draw_icon(id, 1, 160, 0, 0, "dmg_drown")
			case 100: fn_draw_icon(id, 2, 0, 0, 0, "dmg_drown")
		}
	}
}

stock fm_get_user_shield(id)
{
	if (get_pdata_int(id, OFFSET_SHIELD) & HAS_SHIELD)
		return 1
		
	return 0
}

stock fm_get_user_defuse(id)
{
	if(get_pdata_int(id, OFFSET_DEFUSE_PLANT) & HAS_DEFUSE_KIT)
		return 1

	return 0
}

stock fm_get_user_nvg(id)
{
	if(get_pdata_int(id, OFFSET_NVGOGGLES) & HAS_NVGOGGLES)
		return 1
		
	return 0
}

stock fn_texture_type(id)
{
	static Float:afStart[3]
	pev(id, pev_origin, afStart)
    
	static Float:afDest[3]
	afDest[0] = afStart[0]
	afDest[1] = afStart[1]
	afDest[2] = -8191.0

	static tr
	engfunc(EngFunc_TraceLine, afStart, afDest, 0, id, tr)

	static iTexEnt
	iTexEnt = get_tr2(tr, TR_pHit)
	if(iTexEnt == -1)
		iTexEnt = 0
	else if(is_user_alive(iTexEnt))
		return PLUGIN_CONTINUE

	static szTexName[16]
	engfunc(EngFunc_TraceTexture, iTexEnt, afStart, afDest, szTexName, 15)

	static szTexType[2]
	szTexType[0] = dllfunc(DLLFunc_PM_FindTextureType, szTexName)

	return szTexType[0]
}

stock bool:fn_is_silen(id, iWeaponId)
{
	static iWeaponEntIndex
	iWeaponEntIndex = -1

	switch(iWeaponId)
	{
		case CSW_M4A1:
		{
			while((iWeaponEntIndex = engfunc(EngFunc_FindEntityByString, iWeaponEntIndex, "classname", "weapon_m4a1")) && pev(iWeaponEntIndex, pev_owner) != id) {}
			if(pev_valid(iWeaponEntIndex))
				return ((get_pdata_int(iWeaponEntIndex, m_iSilencerFireMode, EXTRAOFFSET_WEAPONS) & M4A1_SILENCED) > 0) ? true : false
		}
		case CSW_USP:
		{
			while((iWeaponEntIndex = engfunc(EngFunc_FindEntityByString, iWeaponEntIndex, "classname", "weapon_usp")) && pev(iWeaponEntIndex, pev_owner) != id) {}
			if(pev_valid(iWeaponEntIndex))
				return ((get_pdata_int(iWeaponEntIndex, m_iSilencerFireMode, EXTRAOFFSET_WEAPONS) & USP_SILENCED) > 0) ? true : false
		}
		case CSW_TMP: return true
	}
	
	return false
}

stock fn_setspeed(id, Float:speed)
{
	engfunc(EngFunc_SetClientMaxspeed, id, speed)
	set_pev(id, pev_maxspeed, speed)
}

stock fn_refresh_score(id)
{
	message_begin(MSG_ALL, g_iMsgScoreInfo)
	write_byte(id)
	write_short(get_user_frags(id))
	write_short(get_user_deaths(id))
	write_short(0)
	write_short(get_user_team(id))
	message_end()
}

stock fn_lights_fx(id, iRadius, iRed, iGreen, iBlue, iLife, iDecay)
{
	static Float:afOrigin[3]
	pev(id, pev_origin, afOrigin)

	message_begin(MSG_ALL, SVC_TEMPENTITY)
	write_byte(TE_DLIGHT)
	engfunc(EngFunc_WriteCoord, afOrigin[0])
	engfunc(EngFunc_WriteCoord, afOrigin[1])
	engfunc(EngFunc_WriteCoord, afOrigin[2])
	write_byte(iRadius)
	write_byte(iRed)
	write_byte(iGreen)
	write_byte(iBlue)
	write_byte(iLife)
	write_byte(iDecay)
	message_end()
}

stock fn_bloody_FX(id)
{
	static aiOrigin[3]
	get_user_origin(id, aiOrigin)

	message_begin(MSG_ALL, SVC_TEMPENTITY)
	write_byte(TE_BLOODSTREAM)
	write_coord(aiOrigin[0])
	write_coord(aiOrigin[1])
	write_coord(aiOrigin[2]+10)
	write_coord(random_num(-30, 30))
	write_coord(random_num(-30, 30))
	write_coord(-10)
	write_byte(70)
	write_byte(random_num(50, 100))
	message_end()

	if(pev(id, pev_flags) & FL_DUCKING)
		aiOrigin[2] -= 18
	else
		aiOrigin[2] -= 36
		
	message_begin(MSG_ALL, SVC_TEMPENTITY)
	write_byte(TE_WORLDDECAL)
	write_coord(aiOrigin[0]+random_num(-5,5))
	write_coord(aiOrigin[1]+random_num(-5,5))
	write_coord(aiOrigin[2])
	write_byte(g_aiBloodSmall[random(4)])
	message_end()
}

stock fn_draw_icon(id, iStatus, iRed, iGreen, iBlue, szName[])
{
	message_begin(MSG_ONE, g_iMsgStatusIcon, {0,0,0}, id)
	write_byte(iStatus)
	write_string(szName)
	write_byte(iRed)
	write_byte(iGreen)
	write_byte(iBlue)
	message_end()
}

stock fn_fade(id, shDuration, shHoldTime, shFlags, iRed, iGreen, iBlue, iAlpha)
{
	message_begin(MSG_ONE, g_iMsgFade, {0,0,0}, id)
	write_short(shDuration)
	write_short(shHoldTime)
	write_short(shFlags)
	write_byte(iRed)
	write_byte(iGreen)
	write_byte(iBlue)
	write_byte(iAlpha)
	message_end()
}

stock fn_shake(id, shAmplitude, shDuration, shFrequency)
{
	message_begin(MSG_ONE, g_iMsgShake, {0,0,0}, id)
	write_short(shAmplitude)
	write_short(shDuration)
	write_short(shFrequency)
	message_end()
}

